diff --git a/src/BRepClass/BRepClass_FaceExplorer.hxx b/src/BRepClass/BRepClass_FaceExplorer.hxx
index 3e404b8..be0ba68 100644
--- a/src/BRepClass/BRepClass_FaceExplorer.hxx
+++ b/src/BRepClass/BRepClass_FaceExplorer.hxx
@@ -17,21 +17,15 @@
 #ifndef _BRepClass_FaceExplorer_HeaderFile
 #define _BRepClass_FaceExplorer_HeaderFile
 
-#include <Standard.hxx>
-#include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
-
-#include <TopoDS_Face.hxx>
+#include <NCollection_Vector.hxx>
+#include <TopClass_GeomEdge.hxx>
 #include <TopExp_Explorer.hxx>
-#include <Standard_Integer.hxx>
-#include <Standard_Real.hxx>
-#include <Standard_Boolean.hxx>
-#include <TopAbs_Orientation.hxx>
-class TopoDS_Face;
-class gp_Pnt2d;
-class gp_Lin2d;
-class BRepClass_Edge;
+#include <TopoDS_Face.hxx>
+#include <TopoDS_Wire.hxx>
+#include <NCollection_List.hxx>
+#include <NCollection_IndexedDataMap.hxx>
 
+class TopClass_RayInfo;
 
 //! Provide an   exploration of a  BRep Face   for the
 //! classification. Return UV edges.
@@ -41,29 +35,23 @@ public:
 
   DEFINE_STANDARD_ALLOC
 
-  
-  Standard_EXPORT BRepClass_FaceExplorer(const TopoDS_Face& F);
+  //! Constructor
+  Standard_EXPORT BRepClass_FaceExplorer(const TopoDS_Face& theF);
 
-  //! Checks the point and change its coords if it is located too far
+  //! Initializes <this>
+  Standard_EXPORT void Init(const TopoDS_Face& theF);
+
+  //! Checks the point and change its coordinates if it is located too far
   //! from the bounding box of the face. New Coordinates of the point 
   //! will be on the line between the point and the center of the 
   //! bounding box. Returns True if point was not changed.
-  Standard_EXPORT Standard_Boolean CheckPoint (gp_Pnt2d& thePoint);
-  
-  //! Should  return  True  if the  point  is  outside a
-  //! bounding volume of the face.
-  Standard_EXPORT Standard_Boolean Reject (const gp_Pnt2d& P) const;
-  
-  //! Returns  in <L>, <Par>  a segment having at least
-  //! one  intersection  with  the   face  boundary  to
-  //! compute  intersections.
-  Standard_EXPORT Standard_Boolean Segment (const gp_Pnt2d& P, gp_Lin2d& L, Standard_Real& Par);
-  
-  //! Returns  in <L>, <Par>  a segment having at least
-  //! one  intersection  with  the   face  boundary  to
-  //! compute  intersections. Each call gives another segment.
-  Standard_EXPORT Standard_Boolean OtherSegment (const gp_Pnt2d& P, gp_Lin2d& L, Standard_Real& Par);
-  
+  Standard_EXPORT Standard_Boolean CheckPoint(gp_Pnt2d& thePoint);
+
+  //! Returns ray to process.
+  Standard_EXPORT Standard_Boolean OtherRay(const gp_Pnt2d& theP,
+                                            TopClass_RayInfo& theRay,
+                                            const unsigned int theMaxRating);
+
   //! Starts an exploration of the wires.
   Standard_EXPORT void InitWires();
   
@@ -71,56 +59,137 @@ public:
     Standard_Boolean MoreWires() const;
   
   //! Sets the explorer  to the  next  wire.
-    void NextWire();
-  
-  //! Returns True  if the wire  bounding volume does not
-  //! intersect the segment.
-  Standard_EXPORT Standard_Boolean RejectWire (const gp_Lin2d& L, const Standard_Real Par) const;
-  
+  void NextWire();
+
   //! Starts an exploration of the  edges of the current
   //! wire.
   Standard_EXPORT void InitEdges();
   
   //! Returns True if there is a current edge.
-    Standard_Boolean MoreEdges() const;
-  
+  Standard_Boolean MoreEdges() const;
+
   //! Sets the explorer  to the  next  edge.
-    void NextEdge();
-  
-  //! Returns True  if the edge  bounding volume does not
-  //! intersect the segment.
-  Standard_EXPORT Standard_Boolean RejectEdge (const gp_Lin2d& L, const Standard_Real Par) const;
-  
-  //! Current edge in current wire and its orientation.
-  Standard_EXPORT void CurrentEdge (BRepClass_Edge& E, TopAbs_Orientation& Or) const;
+  void NextEdge();
+
+  //! Returns analyzed edge.
+  Standard_EXPORT void CurrentEdge(TopClass_GeomEdge& theGE) const;
+
+  //! Returns TRUE if thePnt is covered by the tolerance of at least one
+  //! vertex of the analyzed edge.
+  //! If it is true then stores the parameter of the vertex on the curve.
+  //! Otherwise, returns *theParameter = 0.0.
+  //! This parameter is used in TopOpeBRep class
+  //! and must be deleted after this class will be eliminated.
+  Standard_EXPORT Standard_Boolean IsPointInEdgeVertex(const gp_Pnt2d &thePnt,
+                                                       Standard_Real* const theParameter = 0) const;
+
+  //! Returns 1st considered ray
+  Standard_Boolean FirstRay(const gp_Pnt2d& theP,
+                            TopClass_RayInfo& theRay,
+                            const unsigned int theMaxRating = UINT_MAX)
+  {
+    // May return FALSE in case when the face is an infinite
+    // plane (see bugs modalg_6 bug25937* test cases)
+
+    ResetFields();
+
+    return OtherRay(theP, theRay, theMaxRating);
+  }
+
+  //! Clear private data
+  void ResetFields()
+  {
+    myCurEdgeInd = 1;
+    myCurEdgePar = myProbing_Start;
+  }
+
+  //! This method is used only for compatibility with TopOpeBRep
+  //! packages. It should be deleted after this package will be eliminated.
+  const TopoDS_Edge& GetTopoEdge() const
+  {
+    return myEExplorer.Value().GetTopoEdge();
+  }
+
+  //! Take UVBounds of the face. They are cached on first call.
+  Standard_EXPORT void UVBounds(Standard_Real& theUMin, Standard_Real& theUMax,
+                                Standard_Real& theVMin, Standard_Real& theVMax) const;
 
+protected:
 
+  //! Excludes all necessary information from theEdge
+  //! in order to create pseudo-edges in the future.
+  //! Returns FALSE if pseudo-edge creation is not necessary.
+  //! Returns 2D-point on the myFace (thePnt) respected to
+  //! theCurrentVertex.
+  //! Output parameter theOri indicates if theCurrentVertex
+  //! is first (FORWARD) or last (reversed) vertex of the theEdge.
+  //! ATTENTION!!! theCurrentVertex must be in theEdge.
+  Standard_EXPORT Standard_Boolean
+                    PrepareEdge(const TopoDS_Edge& theEdge,
+                                const TopoDS_Vertex& theCurrentVertex,
+                                gp_Pnt2d& thePnt,
+                                TopAbs_Orientation& theOri);
+
+  //! Inserts topological edge theEdge to myEList without
+  //! any additional checks.
+  Standard_EXPORT void SimpleAdd(const TopoDS_Edge &theEdge);
+
+  //! Creates pseudo-edge between and inserts it to myEList.
+  //! Pseudo-edge is 2D-line, which joins ends of theE1 and theE2
+  //! real edges. This edge does not have any 3D- and topological-
+  //! representations (pseudo-edge is not synonym of degenerated edge).
+  //! I.e. it is simple gap in the myFace. This gap must be covered
+  //! by theVertex (otherwise, myFace is not valid for using in OCCT-algorithms).
+  //! theUPeriod and theVPeriod are periods of myFace (are equal to 0.0 if
+  //! the surface is not periodic)
+  Standard_EXPORT void AddPseudo(const TopoDS_Edge& theE1,
+                                 const TopoDS_Edge& theE2,
+                                 const TopoDS_Vertex& theVertex,
+                                 const Standard_Real theUPeriod,
+                                 const Standard_Real theVPeriod);
 
+private:
 
-protected:
+  //! Classified face
+  TopoDS_Face myFace;
 
+  //! Surface got from the face (it includes location if any)
+  Handle(Geom_Surface) mySurf;
 
+  //! Flag defining whether UV bounds have been computed
+  mutable Standard_Boolean myBoundsComputed;
 
+  //! UV bounds of the face
+  mutable Standard_Real myUMin, myUMax, myVMin, myVMax;
 
+  //! Explores myFace to wires
+  NCollection_IndexedDataMap <TopoDS_Wire,
+                NCollection_List<TopClass_GeomEdge>> myMapWE;
 
-private:
+  //! Iterator of myMapWE
+  NCollection_IndexedDataMap <TopoDS_Wire,
+                      NCollection_List<TopClass_GeomEdge>>::Iterator myWExplorer;
 
+  //! Iterator of myEList
+  NCollection_List<TopClass_GeomEdge>::Iterator myEExplorer;
 
+  //! Ratio of the edge range to form ray
+  static const Standard_Real myProbing_Start, myProbing_End;
 
-  TopoDS_Face myFace;
-  TopExp_Explorer myWExplorer;
-  TopExp_Explorer myEExplorer;
+  //! Step for ratio
+  static const Standard_Real myProbing_Step;
+
+  //! The edge ID to form ray.
+  //! Ray joins the classified point
+  //! with some point of the edge.
   Standard_Integer myCurEdgeInd;
-  Standard_Real myCurEdgePar;
 
+  //! Parameter (on the edge) of the intersection point
+  //! between the ray and the edge
+  Standard_Real myCurEdgePar;
 
 };
 
-
 #include <BRepClass_FaceExplorer.lxx>
 
-
-
-
-
 #endif // _BRepClass_FaceExplorer_HeaderFile
diff --git a/src/BRepClass/BRepClass_Intersector.cxx b/src/BRepClass/BRepClass_Intersector.cxx
index 847d877..c5e5b9d 100644
--- a/src/BRepClass/BRepClass_Intersector.cxx
+++ b/src/BRepClass/BRepClass_Intersector.cxx
@@ -14,38 +14,19 @@
 // Alternatively, this file may be used under the terms of Open CASCADE
 // commercial license or contractual agreement.
 
-
-#include <BRep_Tool.hxx>
-#include <BRepAdaptor_Curve2d.hxx>
-#include <BRepAdaptor_Surface.hxx>
-#include <BRepClass_Edge.hxx>
 #include <BRepClass_Intersector.hxx>
+
+#include <Adaptor3d_HSurface.hxx>
 #include <ElCLib.hxx>
-#include <Extrema_ExtPC2d.hxx>
-#include <Geom2d_Curve.hxx>
 #include <Geom2d_Line.hxx>
 #include <Geom2dInt_GInter.hxx>
 #include <Geom2dLProp_CLProps2d.hxx>
-#include <gp_Dir2d.hxx>
-#include <gp_Lin2d.hxx>
-#include <IntRes2d_Domain.hxx>
-#include <IntRes2d_IntersectionPoint.hxx>
-#include <IntRes2d_Transition.hxx>
-#include <Precision.hxx>
-#include <TopExp.hxx>
-#include <TopoDS_Vertex.hxx>
-
-static 
-void RefineTolerance(const TopoDS_Face& aF,
-                     const BRepAdaptor_Curve2d& aC,
-                     const Standard_Real aT,
-                     Standard_Real& aTolZ);
+#include <TopClass_GeomEdge.hxx>
 
 //=======================================================================
 //function : BRepClass_Intersector
 //purpose  : 
 //=======================================================================
-
 BRepClass_Intersector::BRepClass_Intersector()
 {
 }
@@ -54,170 +35,51 @@ BRepClass_Intersector::BRepClass_Intersector()
 //function : Perform
 //purpose  : 
 //=======================================================================
-void  BRepClass_Intersector::Perform(const gp_Lin2d& L, 
-                                     const Standard_Real P, 
-                                     const Standard_Real Tol, 
-                                     const BRepClass_Edge& E)
+void  BRepClass_Intersector::Perform(const gp_Lin2d& theLin, 
+                                     const Standard_Real thePar,
+                                     const Standard_Real theTol2D,
+                                     const TopClass_GeomEdge& theGE)
 {
-  Standard_Real deb = 0.0, fin = 0.0, aTolZ = Tol;
-  Handle(Geom2d_Curve) aC2D;
-  //
-  const TopoDS_Edge& EE = E.Edge();
-  const TopoDS_Face& F = E.Face();
-
-  //
-  aC2D=BRep_Tool::CurveOnSurface(EE, F, deb, fin);
-  if (aC2D.IsNull()) {
+  if (theGE.IsNull())
+  {
     done = Standard_False; // !IsDone()
     return;
   }
-  //
-  BRepAdaptor_Curve2d C(EE, F);
-  //
-  deb = C.FirstParameter();
-  fin = C.LastParameter();
-  //
-  // Case of "ON": direct check of belonging to edge
-  // taking into account the tolerance
-  Extrema_ExtPC2d anExtPC2d(L.Location(), C);
-  Standard_Real MinDist = RealLast(), aDist;
-  Standard_Integer MinInd = 0, i;
-  if (anExtPC2d.IsDone())
-  {
-    const Standard_Integer aNbPnts = anExtPC2d.NbExt();
-    for (i = 1; i <= aNbPnts; ++i)
-    {
-      aDist = anExtPC2d.SquareDistance(i);
 
-      if (aDist < MinDist)
-      {
-        MinDist = aDist;
-        MinInd = i;
-      }
-    }
-  }
+  const gp_Pnt2d &aPnt2D = theLin.Location();
+  const Standard_Real aParF = theGE.FirstParameter();
+  const Standard_Real aParL = theGE.LastParameter();
+
+  const Geom2dAdaptor_Curve &anAdC2d = theGE.Get2DCurve();
 
-  if (MinInd) {
-    MinDist = sqrt(MinDist);
-  }
-  if (MinDist <= aTolZ) {
-    gp_Pnt2d pnt_exact = (anExtPC2d.Point(MinInd)).Value();
-    Standard_Real par = (anExtPC2d.Point(MinInd)).Parameter();
-    //
-    RefineTolerance(F, C, par, aTolZ);
-    //
-    if (MinDist <= aTolZ) {
-      IntRes2d_Transition tr_on_lin(IntRes2d_Head);
-      IntRes2d_Position pos_on_curve = IntRes2d_Middle;
-      if (Abs(par - deb) <= Precision::Confusion()) {
-        pos_on_curve = IntRes2d_Head;
-      }
-      else if (Abs(par - fin) <= Precision::Confusion()) {
-        pos_on_curve = IntRes2d_End;
-      }
-      //
-      IntRes2d_Transition tr_on_curve(pos_on_curve);
-      IntRes2d_IntersectionPoint pnt_inter(pnt_exact, 0., par,
-        tr_on_lin, tr_on_curve, 
-        Standard_False);
-      //
-      Append(pnt_inter);
-      done = Standard_True;
-      return;
-    }
-  }
   //  
   gp_Pnt2d pdeb,pfin;
-  C.D0(deb,pdeb);
-  C.D0(fin,pfin);
-  Standard_Real toldeb = 1.e-5, tolfin = 1.e-5;
+  anAdC2d.D0(aParF, pdeb);
+  anAdC2d.D0(aParL, pfin);
 
   IntRes2d_Domain DL;
-  //
-  if(P!=RealLast()) {
-    DL.SetValues(L.Location(),0.,Precision::PConfusion(),ElCLib::Value(P,L),P,Precision::PConfusion());
+  if (thePar != RealLast()) {
+    DL.SetValues(aPnt2D, 0., theTol2D, ElCLib::Value(thePar, theLin), thePar, theTol2D);
   }
   else { 
-    DL.SetValues(L.Location(),0.,Precision::PConfusion(),Standard_True);
+    DL.SetValues(aPnt2D, 0., theTol2D, Standard_True);
   }
 
-  IntRes2d_Domain DE(pdeb,deb,toldeb,pfin,fin,tolfin);
-  // temporary periodic domain
-  if (C.Curve()->IsPeriodic()) {
-    DE.SetEquivalentParameters(C.FirstParameter(),
-      C.FirstParameter() + 
-      C.Curve()->LastParameter() -
-      C.Curve()->FirstParameter());
-  }
+  IntRes2d_Domain DE(pdeb, aParF, Precision::PConfusion(), pfin, aParL, Precision::PConfusion());
+
+  // For the future.
+  // There is no point in intersecting geometrical curves. Here,
+  // intersection of line with polygonal-representation of the anAdC2d
+  // will be enough. After we determine the nearest (to the
+  // classified point) edge, only this edge needs to be GEOMETRICALY
+  // intersected with the line (e.g. in order to define correct transition).
+  // Currently, this algorithm is not implemented. Maybe it will be done in the future
+  // (in frame of performance improving)
 
-  Handle(Geom2d_Line) GL= new Geom2d_Line(L);
+  Handle(Geom2d_Line) GL = new Geom2d_Line(theLin);
   Geom2dAdaptor_Curve CGA(GL);
-  Geom2dInt_GInter Inter(CGA,DL,C,DE,
-    Precision::PConfusion(),
-    Precision::PIntersection());
+  Geom2dInt_GInter Inter(CGA, DL, anAdC2d, DE,
+                         Precision::PConfusion(), Precision::PIntersection());
   //
   SetValues(Inter);
-}
-
-//=======================================================================
-//function : LocalGeometry
-//purpose  : 
-//=======================================================================
-void  BRepClass_Intersector::LocalGeometry(const BRepClass_Edge& E, 
-                                           const Standard_Real U, 
-                                           gp_Dir2d& Tang, 
-                                           gp_Dir2d& Norm, 
-                                           Standard_Real& C) const 
-{
-  Standard_Real f,l;
-  Geom2dLProp_CLProps2d Prop(BRep_Tool::CurveOnSurface(E.Edge(),E.Face(),f,l),
-    U,2,Precision::PConfusion());
-  Prop.Tangent(Tang);
-  C = Prop.Curvature();
-  if (C > Precision::PConfusion())
-    Prop.Normal(Norm);
-  else
-    Norm.SetCoord(Tang.Y(),-Tang.X());
-}
-
-//=======================================================================
-//function : RefineTolerance
-//purpose  : 
-//=======================================================================
-void RefineTolerance(const TopoDS_Face& aF,
-                     const BRepAdaptor_Curve2d& aC,
-                     const Standard_Real aT,
-                     Standard_Real& aTolZ)
-{
-  GeomAbs_SurfaceType aTypeS;
-  //
-  BRepAdaptor_Surface aBAS(aF, Standard_False);
-  //
-  aTypeS=aBAS.GetType();
-  if (aTypeS==GeomAbs_Cylinder) {
-    Standard_Real aURes, aVRes, aTolX;
-    gp_Pnt2d aP2D;
-    gp_Vec2d aV2D;
-    //
-    aURes=aBAS.UResolution(aTolZ);
-    aVRes=aBAS.VResolution(aTolZ);
-    //
-    aC.D1(aT, aP2D, aV2D);
-    gp_Dir2d aD2D(aV2D);
-    //
-    aTolX=aURes*aD2D.Y()+aVRes*aD2D.X();
-    if (aTolX<0.) {
-      aTolX=-aTolX;
-    }
-    //
-    if (aTolX < Precision::Confusion()) {
-      aTolX = Precision::Confusion();
-    }
-    //
-    if (aTolX<aTolZ) {
-      aTolZ=aTolX;
-    }
-  }
-}
-
-
+}
\ No newline at end of file
diff --git a/src/BRepClass/BRepClass_Intersector.hxx b/src/BRepClass/BRepClass_Intersector.hxx
index e1b1742..2d79634 100644
--- a/src/BRepClass/BRepClass_Intersector.hxx
+++ b/src/BRepClass/BRepClass_Intersector.hxx
@@ -17,16 +17,10 @@
 #ifndef _BRepClass_Intersector_HeaderFile
 #define _BRepClass_Intersector_HeaderFile
 
-#include <Standard.hxx>
-#include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
-
 #include <Geom2dInt_IntConicCurveOfGInter.hxx>
-#include <Standard_Real.hxx>
-class gp_Lin2d;
-class BRepClass_Edge;
-class gp_Dir2d;
 
+class Geom2dAdaptor_Curve;
+class TopClass_GeomEdge;
 
 //! Intersect an Edge  with a segment.
 //! Implement the Intersector2d required by the classifier.
@@ -40,34 +34,16 @@ public:
   Standard_EXPORT BRepClass_Intersector();
   
   //! Intersect the line segment and the edge.
-  Standard_EXPORT void Perform (const gp_Lin2d& L, const Standard_Real P, const Standard_Real Tol, const BRepClass_Edge& E);
-  
-  //! Returns in <T>,  <N> and <C>  the tangent,  normal
-  //! and  curvature of the edge  <E> at parameter value
-  //! <U>.
-  Standard_EXPORT void LocalGeometry (const BRepClass_Edge& E, const Standard_Real U, gp_Dir2d& T, gp_Dir2d& N, Standard_Real& C) const;
-
-
-
+  //! theTol2D is the 2D-intersection tolerance.
+  Standard_EXPORT void Perform(const gp_Lin2d& theLin,
+                               const Standard_Real thePar,
+                               const Standard_Real theTol2D,
+                               const TopClass_GeomEdge& theGE);
 
 protected:
 
-
-
-
-
 private:
 
-
-
-
-
 };
 
-
-
-
-
-
-
 #endif // _BRepClass_Intersector_HeaderFile
diff --git a/src/BRepClass/FILES b/src/BRepClass/FILES
index 3ead097..783c8ae 100644
--- a/src/BRepClass/FILES
+++ b/src/BRepClass/FILES
@@ -1,16 +1,11 @@
-BRepClass_Edge.cxx
-BRepClass_Edge.hxx
-BRepClass_Edge.lxx
+BRepClass_FClass2dOfFClassifier.hxx
+BRepClass_FClass2dOfFClassifier_0.cxx
+BRepClass_FClassifier.hxx
+BRepClass_FClassifier_0.cxx
 BRepClass_FaceClassifier.cxx
 BRepClass_FaceClassifier.hxx
 BRepClass_FaceExplorer.cxx
 BRepClass_FaceExplorer.hxx
 BRepClass_FaceExplorer.lxx
-BRepClass_FacePassiveClassifier.hxx
-BRepClass_FacePassiveClassifier_0.cxx
-BRepClass_FClass2dOfFClassifier.hxx
-BRepClass_FClass2dOfFClassifier_0.cxx
-BRepClass_FClassifier.hxx
-BRepClass_FClassifier_0.cxx
 BRepClass_Intersector.cxx
-BRepClass_Intersector.hxx
+BRepClass_Intersector.hxx
\ No newline at end of file
diff --git a/src/BRepClass3d/BRepClass3d_Intersector3d.cxx b/src/BRepClass3d/BRepClass3d_Intersector3d.cxx
index 1309b0b..a1da6cf 100644
--- a/src/BRepClass3d/BRepClass3d_Intersector3d.cxx
+++ b/src/BRepClass3d/BRepClass3d_Intersector3d.cxx
@@ -36,9 +36,9 @@ BRepClass3d_Intersector3d::BRepClass3d_Intersector3d()
 }
 //============================================================================
 void BRepClass3d_Intersector3d::Perform(const gp_Lin& L,
-					const Standard_Real /*Prm*/,
-					const Standard_Real Tol,
-					const TopoDS_Face& Face) { 
+                                        const Standard_Real theTol3D,
+                                        const TopoDS_Face& Face)
+{
 
   IntCurveSurface_HInter   HICS; 
   BRepAdaptor_Surface      surface;
@@ -96,15 +96,16 @@ void BRepClass3d_Intersector3d::Perform(const gp_Lin& L,
         Puv.SetY(Y - vperiod * N2);
       }
 
-      classifier2d.Perform(Face,Puv,Tol);
+      classifier2d.Perform(Face, Puv, theTol3D);
       TopAbs_State currentstate = classifier2d.State();
       if(currentstate==TopAbs_IN || currentstate==TopAbs_ON) { 
-	const IntCurveSurface_IntersectionPoint& HICSPoint = HICS.Point(index);
-	Standard_Real HICSW = HICSPoint.W();
-//  Modified by skv - Fri Mar  4 12:07:34 2005 OCC7966 Begin
-	if((W > HICSW) && (HICSW>-Tol)) { 
-// 	if(W > HICSW) { 
-//  Modified by skv - Fri Mar  4 12:07:34 2005 OCC7966 End
+        const IntCurveSurface_IntersectionPoint& HICSPoint = HICS.Point(index);
+        Standard_Real HICSW = HICSPoint.W();
+        
+        // Must be "HICSW > -<Curve Resolution>(theTol3D)" but
+        // the curve is Geom_Line. Therefore, its resolution is equal to theTol3D.
+        if((W > HICSW) && (HICSW>-theTol3D))
+        { 
 	  hasapoint  = Standard_True;
 	  U          = HICSPoint.U();
 	  V          = HICSPoint.V();
diff --git a/src/BRepClass3d/BRepClass3d_Intersector3d.hxx b/src/BRepClass3d/BRepClass3d_Intersector3d.hxx
index 4c6d776..ccb759f 100644
--- a/src/BRepClass3d/BRepClass3d_Intersector3d.hxx
+++ b/src/BRepClass3d/BRepClass3d_Intersector3d.hxx
@@ -43,17 +43,19 @@ public:
   //! Empty constructor.
   Standard_EXPORT BRepClass3d_Intersector3d();
   
-  //! Perform the intersection between the
-  //! segment L(0) ... L(Prm) and the Shape <Sh>.
+  //! Perform the intersection between theL
+  //! and the face <theF>.
   //!
   //! Only the point with the smallest parameter on the
   //! line is returned.
   //!
-  //! The Tolerance <Tol> is used to determine if the
-  //! first point of the segment is near the face. In
+  //! The Tolerance <theTol3D> is used to determine if the
+  //! first point of the segment is near to the face. In
   //! that case, the parameter of the intersection point
-  //! on the line can be a negative value (greater than -Tol).
-  Standard_EXPORT void Perform (const gp_Lin& L, const Standard_Real Prm, const Standard_Real Tol, const TopoDS_Face& F);
+  //! on the line can be equal to a negative value (greater than -Tol).
+  Standard_EXPORT void Perform(const gp_Lin& theL, 
+                               const Standard_Real theTol3D,
+                               const TopoDS_Face& theF);
   
   //! True is returned when the intersection have been computed.
     Standard_Boolean IsDone() const;
diff --git a/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx b/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx
index ae47f52..91246b2 100644
--- a/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx
+++ b/src/BRepClass3d/BRepClass3d_SolidExplorer.cxx
@@ -33,9 +33,8 @@
 #include <BRepBndLib.hxx>
 #include <BRepClass3d_DataMapIteratorOfMapOfInter.hxx>
 #include <BRepClass3d_SolidExplorer.hxx>
-#include <BRepClass_Edge.hxx>
 #include <BRepClass_FaceClassifier.hxx>
-#include <BRepClass_FacePassiveClassifier.hxx>
+#include <BRepClass_FClass2dOfFClassifier.hxx>
 #include <BRepTools.hxx>
 #include <BRepTopAdaptor_FClass2d.hxx>
 #include <ElCLib.hxx>
@@ -134,14 +133,15 @@ Standard_Boolean BRepClass3d_SolidExplorer::FindAPointInTheFace
     Standard_Real TolInit   = 0.00001;
     Standard_Boolean APointExist = Standard_False;
 
-    BRepClass_FacePassiveClassifier FClassifier;
+    BRepClass_FClass2dOfFClassifier FClassifier;
 
     T.Normalize();
     P.SetCoord (P.X() + TolInit * T.X(), P.Y() + TolInit * T.Y());
-    FClassifier.Reset (gp_Lin2d (P, T), ParamInit, RealEpsilon()); //-- Length and Tolerance #######
+    FClassifier.Reset (gp_Lin2d (P, T), ParamInit); //-- Length and Tolerance #######
 
     TopExp_Explorer otherfaceexplorer;
     Standard_Integer aNbEdges = 0;
+    const Handle(Geom_Surface) aSurf = BRep_Tool::Surface(face);
     for (otherfaceexplorer.Init (face, TopAbs_EDGE);
          otherfaceexplorer.More(); 
          otherfaceexplorer.Next(), ++aNbEdges)
@@ -149,8 +149,10 @@ Standard_Boolean BRepClass3d_SolidExplorer::FindAPointInTheFace
       TopoDS_Edge OtherEdge = TopoDS::Edge (otherfaceexplorer.Current());
       if (OtherEdge.Orientation() != TopAbs_EXTERNAL && OtherEdge != Edge)
       {
-        BRepClass_Edge AEdge (OtherEdge, face);
-        FClassifier.Compare (AEdge, OtherEdge.Orientation());
+        Standard_Real aFPar, aLPar;
+        const Handle(Geom2d_Curve) aC2d = BRep_Tool::CurveOnSurface(OtherEdge, face, aFPar, aLPar);
+        TopClass_GeomEdge AEdge(OtherEdge, aSurf, aC2d, aFPar, aLPar);
+        FClassifier.Compare(AEdge, Precision::PConfusion());
         if (FClassifier.ClosestIntersection())
         {
           if(ParamInit > FClassifier.Parameter())
@@ -164,8 +166,10 @@ Standard_Boolean BRepClass3d_SolidExplorer::FindAPointInTheFace
 
     if (aNbEdges == 1)
     {
-      BRepClass_Edge AEdge (Edge, face);
-      FClassifier.Compare (AEdge, Edge.Orientation());
+      Standard_Real aFPar, aLPar;
+      const Handle(Geom2d_Curve) aC2d = BRep_Tool::CurveOnSurface(Edge, face, aFPar, aLPar);
+      TopClass_GeomEdge AEdge(Edge, aSurf, aC2d, aFPar, aLPar);
+      FClassifier.Compare(AEdge, Precision::PConfusion());
       if (FClassifier.ClosestIntersection())
       {
         if (ParamInit > FClassifier.Parameter())
@@ -561,7 +565,7 @@ Standard_Integer BRepClass3d_SolidExplorer::OtherSegment(const gp_Pnt& P,
 
             gp_Pnt2d aPuv(aU, aV);
 
-            classifier2d.Perform(face,aPuv,Precision::PConfusion());
+            classifier2d.Perform(face,aPuv,Precision::Confusion());
 
             TopAbs_State aState = classifier2d.State();
 
